local fuel_multiplier = 2

local NAME = minetest.get_current_modname()

local formspec =
  "size[8,5.5]"..
  "list[current_name;fuel;0,0;1,1;]"..
  "list[current_player;main;0,1.5;8,3;8]" ..
  "list[current_player;main;0,4.7;8,1;]"..
  "bgcolor[#FC05E344;false]" ..
  "listcolors[#fc059db0;#fc059dd0]"

local function update_formspec(pos)
  local meta = minetest.get_meta(pos)
  	local inventory = meta:get_inventory()
	local cfmsp = formspec

	local energy = meta:get_int("energy")
	local energy_max = minetest.get_item_group(minetest.get_node(pos).name, "sparktech_energy_max")

	local rem_en = meta:get_int("rem_energy_")
	local rem_en_or = meta:get_int("rem_energy_or_")

	cfmsp = cfmsp ..
	  sparktech.makebar("progress2.png", 1, 0, 8.5, 0.5,
			    rem_en, rem_en_or, 0)
	
	cfmsp = cfmsp ..
	  sparktech.makebar("energy2.png", 1, 0.5, 8.5, 0.5,
			    energy, energy_max, 0)
	meta:set_string("formspec", cfmsp)
end

minetest.register_node(NAME .. ":burnergenerator", {
  description = "Burner Generator",
  tiles = {    
    "generator2.png",
    "generator2.png",
    "generator2.png",
    "generator2.png",
    "generator2.png",
    "generator.png"},
  paramtype2 = "facedir",
  groups = {
    sparktech_techy = 1,
    sparktech_energy_type = 2,
    sparktech_net_trigger = 1,
    sparktech_energy_max = 5000
  },
  on_construct = function(pos)
    local meta = minetest.get_meta(pos)
    meta:set_string("formspec", formspec)
    meta:set_int("rem_energy_", 0)
    local inv = meta:get_inventory()
    inv:set_size('fuel', 1)
    minetest.get_node_timer(pos):start(0.5)
  end,
  on_timer = function(pos, elapsed) -- Reduce number of ticks like in the furnace
    local meta = minetest.get_meta(pos)

    local rem_energy = meta:get_int("rem_energy_")
    if rem_energy > 0 then
      local change
      if rem_energy > 5 then
	change = 5
      else
	change = rem_energy
      end
      meta:set_int("rem_energy_", meta:get_int("rem_energy_") - change)
      meta:set_int("energy", meta:get_int("energy") + change)
    else
      local inv = meta:get_inventory()
      local itemlist = inv:get_list("fuel")
      local fuel, product = minetest.get_craft_result({method = "fuel", width = 1, items = itemlist})
      local node = minetest.get_node(pos)
      if fuel["time"] ~= 0 then
	inv:set_stack("fuel", 1, product["items"][1])
	
	local fuel_energy = fuel["time"] * fuel_multiplier
	meta:set_int("rem_energy_or_", fuel_energy)
	meta:set_int("rem_energy_", fuel_energy)
      end
    end

    update_formspec(pos) -- Later this should only be done when a player looks into the block
    
    minetest.get_node_timer(pos):start(0.5)
  end
})

minetest.register_craft({
	output = NAME .. ":burnergenerator",
	recipe = {{ 'group:steelplate', 'group:steelplate', 'group:steelplate' },
	  { 'group:steelplate', 'default:clay_brick', 'group:steelplate' },
	  { 'group:steelplate', 'default:copper_ingot', 'group:steelplate' }}
})
